=== debian/control ===
Source: ros-humble-foros
Section: misc
Priority: optional
Maintainer: Wonguk Jeong <wonguk.jeong@42dot.ai>
Build-Depends: debhelper (>= 9.0.0), libleveldb-dev, ros-humble-ament-cmake, ros-humble-ament-cmake-gmock <!nocheck>, ros-humble-ament-cmake-gtest <!nocheck>, ros-humble-ament-lint-common <!nocheck>, ros-humble-foros-msgs, ros-humble-rclcpp, ros-humble-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-humble-foros
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libleveldb-dev, ros-humble-foros-msgs, ros-humble-rclcpp, ros-humble-ros-workspace
Description: Fail Over ROS framework
